#include <iostream.h>
#include "cpu.h"

// Defines the current Process on the CPU
void Cpu::setRunningProcess( Process *p) { 
	cProcess = p ; 
	cRunTotal = 0 ; 
}

// Executes one time unit of CPU.
// The return value is 0 for normal operation or an Interrupt if the 
// Process on the CPU needs attention.
Interrupt *Cpu::doBurst() {
	if( cProcess != 0) { 
		cRunTotal++ ; 
		return cProcess->doCpuBurst() ; 
	}
	return 0 ; 
}

// Removes the current Process from the CPU, leaving it idle...
// until you setRunningProcess() 
void Cpu::removeRunningProcess() { 
	cProcess = 0 ; 
	cRunTotal = 0 ; 
}

// Returns true if the CPU currently has a Process running.
bool Cpu::isBusy() { 
	if( cProcess != 0) { 
		return true ; 
	} 
	else { 
		return false ; 
	} 
}
