#ifndef CPU_H
#define CPU_H

#include "process.h"

// Class: Cpu
// The Cpu class models a CPU in the operating system.
// The CPU job is simple; execute a Process. This is done one time
// unit at a time with the method doBurst().
//
class Cpu { 
public:
	Cpu() { 
		cProcess = 0 ; 
		cRunTotal = 0 ; 
	}

	// Set/Get the Process currently on the CPU. 
	// You can also remove the current Process running, leaving the CPU to idle.
	void setRunningProcess( Process *) ; 
	Process *getRunningProcess() { return cProcess ; }
	void removeRunningProcess() ; 

	// Method: getRunTotal
	// Returns the total CPU time spent on the current Process
	int getRunTotal() { return cRunTotal ; }

	// Returns true if the CPU currently has a Process running on it
	bool isBusy() ; 

	// 
	Interrupt *doBurst() ; 
private:
	Process *cProcess ; 
	int cRunTotal ; 
} ; 

#endif
