#include <iostream.h>
#include <fstream>
#include "billos.h"

using namespace std ; 

//
// main - CSC 420 Program #1
//
// This program simulates the scheduling of processes in an operating system.
// A file of process descriptions is read in, and then siumulated.
// 

int main() { 
	const int	maxNameSize = 100 ; 
	char		fileName[ maxNameSize] ; 
	fstream		dataFile ; 
	fstream		outFile ; 
//	char		c ; 

	// Open the data set file
	cout << "Enter the name of the data set file: " ; 
	cin.getline( fileName, maxNameSize) ; 
	dataFile.open( fileName, ios::in) ; 
	if( !dataFile) { 
		cout << "Error: Bad data set file" ; 
		exit( 1) ; 
	}

	// Open the output file
	outFile.open( "output.txt", ios::out) ; 
	if( !outFile) { 
		cout << "Error: Can't open output file output.txt" << endl ; 
		exit( 1) ; 
	}
	outFile << "DATA SET: " << fileName << endl ; 

	// Create the OS object... init, run and done!
	BillOs		theOS ; 

	theOS.setTimeSlice( 10) ; 
	theOS.addProcessFile( dataFile, outFile) ; 
	theOS.init() ; 
//	cout << "init" << endl ; 
//	cout << "Hit enter..." ; 
//	cin.get( c) ; 

	theOS.run() ; 
//	cout << "run" << endl ; 
//	cout << "Hit enter..." ; 
//	cin.get( c) ; 

	theOS.outputStats( outFile) ; 
	outFile.close() ; 

	cout << "Simulation completed at system clock=" << theOS.getSystemClock() << endl ; 
	return 0 ; 
}
