#ifndef PageTable_H
#define PageTable_H

//
// Class: PageTable
//
class PageTable { 
public:

	PageTable( int addressBits) ; 

	int		getNumAddressBits() { return pAddressBits ; }
	int		getSize()			{ return pTableSize ; }

    // Each of these needs to return an "invalid page" error
	bool	isPageInRange( int page) ; 
	bool	isPageValid( int page) ; 
	int		getFrame( int page) ; 
	void	setFrame( int page, int frame) ; 
	void	unsetFrame( int page) ; 

	int		getTimeOfUse( int page) ; 
	void	setTimeOfUse( int page, int time) ; 

	void	debug( fstream &outFile) ; 

private:
	int		pAddressBits ; 
	int		pTableSize ; 

// This class is only used by PageTable.

	typedef struct {
		int		frame ; 
		int		timeOfUse ; 
		bool	valid ; 
		bool	dirty ; 
	} PageTableEntry ; 

	PageTableEntry	*pTable ; 
} ; 

#endif
